TCK Results
===========

As required by the
[Eclipse Foundation Technology Compatibility Kit License](https://www.eclipse.org/legal/tck.php),
following is a summary of the TCK results for releases of Jakarta Mail.

# 2.0.1 Certification Request

- [x] Organization Name ("Organization") and, if applicable, URL:<br/>
  [Eclipse Foundation](https://www.eclipse.org/)
- [x] Product Name, Version and download URL (if applicable):<br/>
  [EE4J implementation of Jakarta Mail 2.0.1](https://eclipse-ee4j.github.io/mail/)
- [x] Specification Name, Version and download URL:<br/>
   [Jakarta Mail 2.0](https://jakarta.ee/specifications/mail/2.0/)
- [x] TCK Version, digital SHA-256 fingerprint and download URL:<br/>
  [Jakarta Mail TCK 2.0.0](https://download.eclipse.org/jakartaee/mail/2.0/jakarta-mail-tck-2.0.0.zip), SHA-256: 9bc321997af2e4c7837a6b16e9231bdc8a34e0b97fa6dfafdd792fc316721c3b
- [x] Public URL of TCK Results Summary:<br/>
  [TCK results summary](https://eclipse-ee4j.github.io/mail/TCK-Results.html)
- [x] Any Additional Specification Certification Requirements:<br/>
  None
- [x] Java runtime used to run the implementation:<br/>
  Oracle JDK 1.8.0_251, Oracle JDK 11.0.10
- [x] Summary of the information for the certification environment, operating system, cloud, ...:<br/>
  Apache James mail server 3.0.1, Linux
- [x] By checking this box I acknowledge that the Organization I represent accepts the terms of the [EFTL](https://www.eclipse.org/legal/tck.php).
- [x] By checking this box I attest that all TCK requirements have been met, including any compatibility rules.

Test results:

```
[javatest.batch] Completed running 321 tests.
[javatest.batch] Number of Tests Passed      = 321
[javatest.batch] Number of Tests Failed      = 0
[javatest.batch] Number of Tests with Errors = 0
[javatest.batch] Number of Tests Not Run     = 0
```

# 2.0.0 Certification Request

- [x] Organization Name ("Organization") and, if applicable, URL:<br/>
  [Eclipse Foundation](https://www.eclipse.org/)
- [x] Product Name, Version and download URL (if applicable):<br/>
  [EE4J implementation of Jakarta Mail 2.0.0](https://eclipse-ee4j.github.io/mail/)
- [x] Specification Name, Version and download URL:<br/>
   [Jakarta Mail 2.0](https://jakarta.ee/specifications/mail/2.0/)
- [x] TCK Version, digital SHA-256 fingerprint and download URL:<br/>
  [Jakarta Mail TCK 2.0.0](https://download.eclipse.org/jakartaee/mail/2.0/jakarta-mail-tck-2.0.0.zip), SHA-256: 9bc321997af2e4c7837a6b16e9231bdc8a34e0b97fa6dfafdd792fc316721c3b
- [x] Public URL of TCK Results Summary:<br/>
  [TCK results summary](https://eclipse-ee4j.github.io/mail/TCK-Results.html)
- [x] Any Additional Specification Certification Requirements:<br/>
  None
- [x] Java runtime used to run the implementation:<br/>
  Oracle JDK 1.8.0_191
- [x] Summary of the information for the certification environment, operating system, cloud, ...:<br/>
  Apache James mail server 3.0.1, Linux
- [x] By checking this box I acknowledge that the Organization I represent accepts the terms of the [EFTL](https://www.eclipse.org/legal/tck.php).
- [x] By checking this box I attest that all TCK requirements have been met, including any compatibility rules.

Test results:

```
[javatest.batch] Number of Tests Passed      = 321
[javatest.batch] Number of Tests Failed      = 0
[javatest.batch] Number of Tests with Errors = 0
```

# 1.6.4 Certification Request

- [x] Organization Name ("Organization") and, if applicable, URL:<br/>
  [Eclipse Foundation](https://www.eclipse.org/)
- [x] Product Name, Version and download URL (if applicable):<br/>
  [EE4J implementation of Jakarta Mail 1.6.4](index.html)
- [x] Specification Name, Version and download URL:<br/>
   [Jakarta Mail 1.6](https://jakarta.ee/specifications/mail/1.6/)
- [x] TCK Version, digital SHA-256 fingerprint and download URL:<br/>
  [Jakarta Mail TCK 1.6.0](https://download.eclipse.org/jakartaee/mail/1.6/eclipse-mail-tck-1.6.0.zip), SHA-256: fb1a4195b6b91321bbdcc64683aec1e98939c9695679c720a1c7c5b14e4f8e56
- [x] Public URL of TCK Results Summary:<br/>
  [TCK results summary](TCK-Results.html)
- [x] Any Additional Specification Certification Requirements:<br/>
  None
- [x] Java runtime used to run the implementation:<br/>
  Oracle JDK 1.8.0_191
- [x] Summary of the information for the certification environment, operating system, cloud, ...:<br/>
  Apache James mail server 3.0.1, Linux
- [x] By checking this box I acknowledge that the Organization I represent accepts the terms of the [EFTL](https://www.eclipse.org/legal/tck.php).
- [x] By checking this box I attest that all TCK requirements have been met, including any compatibility rules.

Test results:

```
[javatest.batch] Completed running 321 tests.
[javatest.batch] Number of Tests Passed      = 321
[javatest.batch] Number of Tests Failed      = 0
[javatest.batch] Number of Tests with Errors = 0
[javatest.batch] Number of Tests Not Run     = 0
```
