# Third-Party Products

<FONT SIZE="-1">(Last updated Oct 16, 2017)</FONT>

Links to third-party products related to the Jakarta Mail APIs. Send us
a note at <A HREF="https://accounts.eclipse.org/mailing-list/mail-dev">mail-dev@eclipse.org</A>
if you want your product listed here.

* Sending emails in Java should be easier. Jodd provides some nice
  classes for sending emails in an easier, practical way.
  Jodd Email is available at
  <A HREF="https://jodd.org/email/">https://jodd.org/email/</A>

* simple-java-mail is a very simple Java mailing API for sending simple
  to complex emails.  It's a wrapper for the JavaMail smtp support.
  simple-java-mail is available at
  <A HREF="https://github.com/bbottema/simple-java-mail/">
  https://github.com/bbottema/simple-java-mail/</A>

* exJello is a JavaMail provider that connects to a Microsoft Exchange
  server (actually, it uses the WebDAV interface exposed by Outlook Web
  Access).  It is designed as a drop-in replacement for the standard
  POP3 and SMTP providers.  This allows you to send and receive messages
  through your Exchange server in situations where a POP3/SMTP interface
  is not available (through a restrictive firewall, for example, or if
  your administrator simply does not provide a POP3 or SMTP gateway).
  Available at:
  <A HREF="http://code.google.com/p/exjello/">http://code.google.com/p/exjello/</A>

* mailxel is a personal mail store and mail client with focus on
  management and organization of high volume mail boxes. Like gmail,
  but private.  The main features are: fast search, tagging, GTD
  inbox management workflow, efficient data storage, address
  management, automated server-side mail folder organization, normal
  mail functionality (send, recieve, forward etc etc).
  Available at:
  <A HREF="http://code.google.com/p/mailxel/">
  http://code.google.com/p/mailxel/</A>

* libpst - A Java library to read Microsoft proprietary PST files.
  Available at:
  <A HREF="https://github.com/rjohnsondev/java-libpst">
  https://github.com/rjohnsondev/java-libpst</A>

* Apache POI - the Java API for Microsoft Documents.
  The Apache POI Project's mission is to create and maintain Java
  APIs for manipulating various file formats based upon the Office
  Open XML standards (OOXML) and Microsoft's OLE 2 Compound Document
  format (OLE2). In short, you can read and write MS Excel files
  using Java. In addition, you can read and write MS Word and MS
  PowerPoint files using Java.  The project has recently added
  support for Outlook (HSMF), which allows reading Outlook MSG
  files.  At this time, it provides simple read access to some of the
  textual content of MSG files.
  Available at:
  <A HREF="http://poi.apache.org/">http://poi.apache.org/</A>

* Cubusmail is a Ajax based IMAP mail client which has a desktop application
  like user interface.  It provides functions like MIME support, address book,
  folder manipulation, drag & drop and message searching.
  Available at:
  <A HREF="http://code.google.com/p/cubusmail">
  http://code.google.com/p/cubusmail</A>

* DKIM for JavaMail is an open source library that allows you to sign
  a message with
  <A HREF="http://dkim.org/">DomainKeys Identified Mail</A> (DKIM).
  Available at:
  <A HREF="http://www.agitos.de/dkim-for-javamail/">
  http://www.agitos.de/dkim-for-javamail/</A>

* j-XChange is a pure Java implementation of the entire Collaboration Data
  Objects (CDO 1.21) library for accessing Microsoft Exchange Servers in a
  platform independent manner.  Available at:
  <A HREF="http://sourceforge.net/projects/j-xchange">
  http://sourceforge.net/projects/j-xchange</A>

* Jack Mail Client is a simple mail client that uses any mail server
  with minimal configuration.  Jack Mail Client is written in pure Java
  and is available under the GPL license at:
  <A HREF="http://sourceforge.net/projects/jackmailclient">
  http://sourceforge.net/projects/jackmailclient</A>

* GreenMail is an embeddable, lightweight and sandboxed email server for
  testing and developing purposes.  Available at:
  <A HREF="http://www.icegreen.com/greenmail">
  http://www.icegreen.com/greenmail</A>

* Aspirin is an embeddable send-only SMTP server that reuses parts
  of the Apache James mail server.  Available at:
  <A HREF="https://github.com/masukomi/aspirin">
  https://github.com/masukomi/aspirin</A>

* JEC provides a pure Java API to access Microsoft Exchange Server. 
  With it you can access and manipulate emails, calendar, contacts, and tasks
  in the Exchange server.  It supports 2 types of licenses -
  1) Non-Profits, Academic Institutions, and Private Individuals, and
  2) commercial.  For more information see:
  <A HREF="http://www.javaexchangeconnector.com/">
  http://www.javaexchangeconnector.com/</A>

* yawebmail is a webmail-client written in Java as a webapp.
  It supports SMTP (including SMTP-Authentication), POP3 and IMAP.
  Just put the yawebmail.war file into the deployment-directory of your
  Servlet-container (tomcat, jetty, weblogic, ..) and you're ready to go!
  Take a test ride on the yawebmail-Homepage!
  <A HREF="http://yawebmail.sourceforge.net/">
  http://yawebmail.sourceforge.net/</A>

* Aperture is a Java framework for extracting and querying full-text
  content and metadata from various information systems (e.g. file
  systems, web sites, mail boxes) and the file formats (e.g.
  documents, images) occurring in these systems. It provides a
  JavaMail-based incremental IMAP crawler.  Available at:
  <A HREF="http://aperture.sourceforge.net/">
  http://aperture.sourceforge.net/</A>

* JCharset - a charset provider that handles UTF-7, which is a mail safe
  version of Unicode (RFC 2152), and some other charsets that aren't
  currently supported by Java.
  This package is open source (GNU), and it would probably help many JavaMail
  fans out there.  Available at:
  <A HREF="http://www.freeutils.net/source/jcharset/">
  http://www.freeutils.net/source/jcharset/</A>

* The jmbox project (read jambox) enables developers to use the
  JavaMail API to manage mail stored in local repositories like
  Outlook Express, Mozilla, Netscape, etc.  A JavaMail enabled
  application needs only to include the jmbox distribution jar in its
  classpath to automatically benefit from local mail management, the
  same way it would do with POP3 or IMAP remote mail.  At the moment
  jmbox supports navigation and reading from Outlook Express 5/6 mail
  (dbx format).  Writing into folders and support for other
  repositories (mbox) will be added.  Available at:
  <A HREF="https://sourceforge.net/projects/jmbox/">
  https://sourceforge.net/projects/jmbox/</A>.

* hipergate has a WebMail client and local store provider based on
  JavaMail.  hipergate stores e-mail messages in the local filesytem
  of a web server, indexes them using a relational database and makes
  them available through a web interface.  JavaMail is tightly
  integrated with the hipergate Contact Manager and can keep track of
  any sent or received messages for each contact listed in the agenda.
  Available at:
  <A HREF="http://www.hipergate.org">http://www.hipergate.org</A> and
  <A HREF="http://sourceforge.net/projects/hipergate/">
  http://sourceforge.net/projects/hipergate/</A>

* jASEN is a pure Java Anti Spam ENgine combining bayesian-like scanning with 
  intelligent email inspection and classification.
  jASEN is best suited to developers wishing to integrate anti-spam services 
  into an existing server based Java email application, but can be used for 
  client applications.  Available at:
  <A HREF="http://www.jasen.org">http://www.jasen.org</A>

* SplashMail is a simple, free, source-available web application for
  accessing your email over the web.  It may be simple, but it provides
  all the common features most users need.  Available at:
  <A HREF="http://www.twinfeats.com/tf/twinfeats/Java/SplashMail/index.tfs">
  http://www.twinfeats.com/tf/twinfeats/Java/SplashMail/index.tfs</A>

* mstor is a local store provider for JavaMail.  Based on the mbox
  format, mstor facilitates the storage and retrieval of email messages
  in the local filesystem.  In addition, mstor supports additional
  metadata not inherently supported by the mbox format, and is designed
  to handle large mailboxes without a significant degradation in
  performance.  Available at:
  <A HREF="http://mstor.sourceforge.net/index.html">
  http://mstor.sourceforge.net/index.html</A>

* IAIK-CMS with S/MIMEv3 provides a complete implementation of the
  CMS, S/MIMEv3 and ESS (Enhanced Security Services for S/MIME)
  protocols.  It can be used for signing, encrypting, digesting,
  authenticating any kind of digital data and enhances the JavaMail
  API with the cryptographic services of the S/MIME and ESS
  standards.  It comes with a great variety of cryptographic
  algorithms, supports data compression according to S/MIMEv3.1, and
  allows easy integration of smartcards or other hardware security
  modules.  Please see
  <A HREF="http://jcewww.iaik.at/sic/Products/Communication_Messaging_Security/CMS-S_MIME">
  http://jcewww.iaik.at/sic/Products/Communication_Messaging_Security/CMS-S_MIME</A>

* JavaMail-Crypto is a simple, easy-to-use API that provides a unified way to 
  access OpenPGP and S/MIME encryption functionality with JavaMail.  It is 
  released under the LGPL, and available at 
  <A HREF="http://javamail-crypto.sourceforge.net/">
  http://javamail-crypto.sourceforge.net/</A>

* Mousetrap Mail is a free email client written in Java.
  Available at:
  <A HREF="http://mousetrap.sourceforge.net/">http://mousetrap.sourceforge.net/</A>

* PGPMime for Java: A JavaMail extension allowing encryption and signing
  using the PGP/MIME standard.
  Available at:
  <A HREF="http://jpgpmime.sourceforge.net/">http://jpgpmime.sourceforge.net/</A>

* JTNEF: A Java TNEF package for processing TNEF streams (WINMAIL.DAT
  attachments) in email messages sent by Outlook and Exchange.
  Available at:
  <A HREF="http://www.freeutils.net/source/jtnef/">
  http://www.freeutils.net/source/jtnef/</A>

* JavaMaildir is a local Store provider for the JavaMail API that
  provides access to qmail-style Maildir folders with some extensions.
  Available at:
  <A HREF="http://javamaildir.sourceforge.net/">http://javamaildir.sourceforge.net/</A>

* Ebitec's JMS Mail bridge is a software product that interfaces
  between traditional e-mail protocols (SMTP, POP) and a
  JMS server.  The Ebitec Mail Bridge is independent of
  JMS server vendor and therefore easily integrated into your
  existing systems.  Advanced features are included such as
  processing different types of e-mail with multiple attachments,
  encode e-mail into XML, and support for both queues and topics.
  Search for it at:
  <A HREF="http://www.componentsource.com">
  http://www.componentsource.com</A>

* JDAVMail is a JavaMail service provider allowing JavaMail-compliant
  clients to access HotMail mailboxes (read/delete/move/copy mail,
  create/rename/delete folders, ...).  JDAVMail implements the
  WebDAV-like protocol used by some HotMail clients.  The package is
  published under the LGPL license and is available at
  <A HREF="http://jdavmail.sourceForge.net">
  http://jdavmail.sourceForge.net</A>

* email client demo program from
  <A HREF="http://www.amazon.com/exec/obidos/ISBN=0596007019/javasoftsunmicroA">
  The Java Cookbook</A>.  Source code is available for download at:
  <A HREF="http://javacook.darwinsys.com/">http://javacook.darwinsys.com/</A>

* jwma is a WebMail implementation in Java, depending on an IMAP
  server as post office, and an SMTP server for mail transport.
  jwma is an open source project.
  <A HREF="http://jwma.sourceforge.net">http://jwma.sourceforge.net</A>

* PlexMailer offers a set of powerful tools to prevent against
  unsolicted emails (SPAM).  It supports POP3, IMAP, and MBOX
  protocols and can be run as an email client or as a proxy server
  between a mail server and another email client.  PlexMailer comes
  with dozens of filters and hooks to other online resources such as
  ORBS, MAPS, and DUL to protect against unsolicited emails and
  report senders of those emails to appropriate authorities.  It
  supports Java Web Start for seamless installation and automatic
  upgrades for future enhancements and bug fixes.  Available at:
  <A HREF="http://www.plexobject.com/software/plexmailer/">
  http://www.plexobject.com/software/plexmailer/</A>.

* Pooka: An email client using JavaMail and Swing.  Supports IMAP
  (including disconnected IMAP and IMAP over SSL), POP3, and local
  mbox stores.  Source is available under the GNU GPL.  Available at:
  <A HREF="http://www.suberic.net/pooka/">http://www.suberic.net/pooka/</A>.

* A sample application using the Devsphere Mapping Framework:
  A servlet called FormMailer converts data collected with HTML 
  forms to objects and then to key-value pairs. The obtained ASCII 
  text is mailed to one or more addresses using JavaMail.
  A standalone application called MailMonitor uses JavaMail to get 
  the messages from the mail server. Then, it converts the obtained 
  key-value pairs to objects, which are forwarded to a dynamically 
  loaded class for processing.  The application is described in
  Chapters 12-17 of the Developer's Guide, available at
  <A HREF="http://www.devsphere.com/mapping/docs/guide/application.html">
  http://www.devsphere.com/mapping/docs/guide/application.html</A>.
  An evaluation copy of the Devsphere Mapping Framework is available at
  <A HREF="http://www.devsphere.com">http://www.devsphere.com</A>.

* Sak&eacute; Mail: A web-based mail client implemented as a Java servlet
  using JavaMail.
  Available at: <A HREF="http://www.endymion.com/products/sake/mail/">
  http://www.endymion.com/products/sake/mail/</A>.

* Apache JAMES: The Java Apache Mail Enterprise Server (a.k.a. Apache
  James) is a 100% pure Java server designed to be a complete and
  portable enterprise mail engine solution based on currently
  available open protocols (SMTP, POP3, IMAP, HTTP).
  Available at: <A HREF="http://james.apache.org">http://james.apache.org</A>

* Apache JetSpeed: An Open Source GroupWare/Portal product similar to
  Lotus Notes or Microsoft Exchange that implements portal features
  such as My Netscape and My Yahoo.
  Available at: <A HREF="https://portals.apache.org/jetspeed-2/">
  https://portals.apache.org/jetspeed-2/</A>

* An MH provider, from the folks who bring you ICEMail. Available at:  
  <A HREF="http://www.trustice.com/java/icemh">http://www.trustice.com/java/icemh</A>.
